function T=recover_affine_transform(P1,P2)
% This function recovers the 3x3 matrix T that represents the 2D affine
% transformation that transforms the points in P1 to points in P2.
% That is P2=T*P1 (in homogenous coordinates)
% Inputs P1 and P2 are both 2xN arrays representing N 2D points.

% Written by:
% Nazar Khan
% PUCIT
% January 2015

N=size(P1,2);

%% form matrix A
A=zeros(2*N,6);
%---------------- ADD CODE HERE ----------------

%% form vector b
b=zeros(2*N,1);
%---------------- ADD CODE HERE ----------------

%% recover best affine transform via pseudoinverse
v=%---------------- ADD CODE HERE ----------------
T=[v(1) v(2) v(3); v(4) v(5) v(6); 0 0 1];