function I1=warp_image(I,T)
% This function warps an image I using the transformation T.
% Input T is a 3x3 matrix that can represent:
%   a 2D affine transformation, or
%   a 2D projective transformation (also called homography)
% Output I1 is the transformed image.

% Written by:
% Nazar Khan
% PUCIT
% January 2015

%% convert to grayscale in case of colored image
if ndims(I)==3
    I=rgb2gray(I);
end
%% convert to double
I=double(I);

%% estimate size of transformed image I1
[r,c]=size(I);
corners=[1 1 r r;1 c 1 c];                  %the 4 corners of image I
new_corners=transform_points(corners,T);    %transformed corner positions
min_pixel=floor(min(new_corners,[],2));     %min_pixel
max_pixel=ceil(max(new_corners,[],2));      %max_pixel
new_size=max_pixel-min_pixel+1;
r1=new_size(1);
c1=new_size(2);
I1=zeros(r1,c1);

%% apply inverse transformation to every point in I1
Tinv=inv(T);
for i=1:r1
    for j=1:c1
        %setup the point x1
        x1 = [i;j] + min_pixel(1:2);
        
        %inverse transform x1 to location x in I
        x = transform_points(x1,Tinv);
        
        %perform bilinear interpolation to get 
        %appropriate color for I1(x1) from
        %the 4 neighbours of location x in I
        %---------------- ADD CODE HERE ----------------
    end
end
end

function tpts=transform_points(pts,T)
%convert to homogenous coordinates if required
if size(pts,1)==2
    pts(3,:)=1;
end

%apply transformation
tpts=%---------------- ADD CODE HERE ----------------

%convert back to cartesian coordinates
%---------------- ADD CODE HERE ----------------
end